#include "lcd.h"

void wait()
{
	asm volatile ("nop");
    asm volatile ("nop");
    asm volatile ("nop");
}
void send_byte( u8 d)
{
  u8 i;
  

  for( i = 8; i; i-- ){
    SCK_Pin = 0;
    IO_Pin = 0;
    if( d & 0x80 )
      IO_Pin = 1;
    d <<= 1;
	wait();
    SCK_Pin = 1;
	wait();
  }
  SCK_Pin = 0;
  _delay_us( 45 );			// 45us
}


void lcd_command( u8 d )
{
  LCD_RS = 0;
  LCD_CS = 0;
  send_byte( d);
  LCD_CS = 1;
  switch( d ){
    case 1:
    case 2:
    case 3: _delay_ms( 2 );		// wait 2ms
  }
}


void lcd_data( u8 d )
{
  LCD_RS = 1;
  LCD_CS = 0;
  send_byte( d);
  LCD_CS = 1;
}


void lcd_text_( u8 *t )
{
  while( *t ){
    lcd_data( *t );
    t++;
  }
}


void init( void )
{
  LCD_DDR_RS = 1;
  DDR_IO = 1;
  DDR_SCK = 1;
  LCD_DDR_CS = 1;
  LCD_CS = 1;
  RTC_DDR_CS = 1;
  RTC_CS = 0;
  _delay_ms( 15 );			// wait 15ms
#ifdef      EA_DOGM081
  lcd_command( 0x31 );
  lcd_command( 0x1C );
  lcd_command( 0x51 );
  lcd_command( 0x6A );
  lcd_command( 0x74 );
#elif defined    EA_DOGM162
  lcd_command( 0x39 );
  lcd_command( 0x1C );
  lcd_command( 0x52 );
  lcd_command( 0x69 );
  lcd_command( 0x74 );
#elif defined    EA_DOGM163
  lcd_command( 0x39 );
  lcd_command( 0x1D );
  lcd_command( 0x50 );
  lcd_command( 0x6C );
  lcd_command( 0x7C );
#else
#error No LCD type defined !!!
#endif
  lcd_command( 0x0F );
  lcd_command( 0x01 );
  lcd_command( 0x06 );
  lcd_command( 0x0C );			// on, no cursor, no blink
}


void lcd_pos( u8 line, u8 column )
{
  switch( line ){
#ifdef      EA_DOGM163
    case 2: column += 0x10;
    case 1: column += 0x10;
#else
    case 1: column += 0x40;
#endif
  }
  lcd_command( 0x80 + column );
}
