
#include "main.h"
//  Schreib-  Lese- Kommando
//  0x80      0x81  Sekunden
//  0x82      0x83  Minuten
//  0x84      0x85  Stunde
//  0x86      0x87  Tag (1..31)
//  0x88      0x89  Monat
//  0x8A      0x8B  Wochentag (1..7)
//  0x8C      0x8D  Jahr (00..99)
//  0x8E      0x8F  WriteProtect-Bit
//  0x90      0x91  Trickle Charger
//  0xC0      0xC1  RAM 00
//  0xC2      0xC3  RAM 01
//  0xC4      0xC5  RAM 02
//  ...       ...   ...
//  0xFC      0xFD  RAM 1F

// Schalter rechts PB0
// Schalter mitte PB1
// Schalter links PB2


int main(void)
{
	uint temp = 0xFF;
	init();
	init_timer();
	second = 0;
	RTC_Init();
	GIMSK |= (1<<PCIE1);
	PCMSK1 |= (1<<PCINT8)|(1<<PCINT9)|(1<<PCINT10);
	sei();
	char Buffer[10];
	while(1)
	{
		_delay_ms(20);
		cli();
		lcd_command(0x01);
		lcd_pos(0,0);
		RTC_GetTime();
		if(uhr.hrs < 10)
			lcd_data(' ');
		itoa( uhr.hrs, Buffer, 10 );
  		lcd_text(Buffer);
		lcd_data(':');
		if(uhr.min < 10)
			lcd_data('0');
		itoa( uhr.min, Buffer, 10 );
  		lcd_text(Buffer);
		lcd_data(':');
		if(uhr.sec < 10)
			lcd_data('0');
		itoa( uhr.sec, Buffer, 10 );
  		lcd_text(Buffer);
		lcd_data(' ');
		lcd_data(' ');
		itoa( temp, Buffer, 10 );
		lcd_text(Buffer);
		lcd_pos(1,0);
		lcd_text(dow_text[(uhr.dow-1)]);
		lcd_data(' ');
		if(uhr.day < 10)
			lcd_data('0');
		itoa( uhr.day, Buffer, 10 );
  		lcd_text(Buffer);
		lcd_data('.');
		if(uhr.month < 10)
			lcd_data('0');
		itoa( uhr.month, Buffer, 10 );
  		lcd_text(Buffer);
		lcd_data('.');
		lcd_data('2');
		lcd_data('0');
		if(uhr.year < 10)
			lcd_data('0');
		itoa( uhr.year, Buffer, 10 );
  		lcd_text(Buffer);
		lcd_pos(2,0);
		lcd_text(mode_text[mode]);
		if(t1_pre != 0)
			t1_pre--;
		if(t2_pre != 0)
			t2_pre--;
		if(t3_pre != 0)
			t3_pre--;
		if( second == 1 )
		{
     	 	start_meas();
      		second = 2;
    	}
    	if( second == 3 )
		{
      		temp = read_meas();
      		second = 0;
    	}
		sei();
	}
}
ISR(PCINT1_vect)
{
	cli();
	if((PINB&(1<<PB0))&&t1_pre == 0)
	{
		if(mode < 6 )
			mode++;
		else
			mode = 0;

		t1_pre = 10;
	}
	if((PINB&(1<<PB1))&&t2_pre == 0)
	{
		if(mode == 0)
		{
			uhr.sec = 0;
		}
		if(mode == 1)
		{
			uhr.min++;
			if(uhr.min == 60)
				uhr.min = 0;
		}
		if(mode == 2)
		{
			uhr.hrs++;
			if(uhr.hrs == 24)
				uhr.hrs = 0;
		}
		if(mode == 3)
		{
			uhr.day++;
			if(uhr.day == 31)
				uhr.day = 0;
		}
		if(mode == 4)
		{
			uhr.month++;
			if(uhr.month == 13)
				uhr.month = 1;
		}
		if(mode == 5)
		{
			uhr.year++;
			if(uhr.year == 100)
				uhr.year = 0;
		}
		if(mode == 6)
		{
			uhr.dow++;
			if(uhr.dow == 7)
				uhr.dow = 1;
		}
		RTC_SetTime();
		t2_pre = 10;
	}
	if((PINB&(1<<PB2)) && t3_pre == 0)
	{
		if(mode == 0)
		{
			uhr.sec = 0;
		}
		if(mode == 1)
		{
			uhr.min--;
			if(uhr.min == 0)
				uhr.min = 59;
		}
		if(mode == 2)
		{
			if(uhr.hrs == 0)
				uhr.hrs = 23;
			else uhr.hrs--;
		}
		if(mode == 3)
		{
			uhr.day--;
			if(uhr.day == 0)
				uhr.day = 31;
		}
		if(mode == 4)
		{
			uhr.month--;
			if(uhr.month == 0)
				uhr.month = 12;
		}
		if(mode == 5)
		{
			if(uhr.year == 0)
				uhr.year = 99;
			else
				uhr.year--;
		}
		if(mode == 6)
		{
			uhr.dow--;
			if(uhr.dow == 0)
				uhr.dow = 7;
		}
		RTC_SetTime();
		t3_pre = 10;
	}
	sei();
}
